\set{capture}{hidden}
\begin{code}

module C.Example (
	example, translated_example
) where

import Additional
import C
import Lambda

example :: TranslationUnitT
example = Un (U0 (FunctionDefinition example_swap)) (FunctionDefinition example_sort)

example_swap 		= Function (Just (DeclarationSpecifier (VoidSpecifier) (Nothing))) (example_swap_r) (Nothing) (example_swap_s)
example_swap_r		= Declarator (Nothing) (PrototypeDeclarator (IdentifierDeclarator "iswap") (FixedParameters (Pn (P0 example_swap_a) (example_swap_b))))
example_swap_a		= NamedParameter (DeclarationSpecifier (IntSpecifier) (Nothing)) (Declarator (Just (Pointer Nothing)) (IdentifierDeclarator "a"))
example_swap_b		= NamedParameter (DeclarationSpecifier (IntSpecifier) (Nothing)) (Declarator (Just (Pointer Nothing)) (IdentifierDeclarator "b"))
example_swap_s		= CompoundStatement (Just example_swap_dl) (Just example_swap_sl)
example_swap_dl		= D0 (Declaration (DeclarationSpecifier (IntSpecifier) (Nothing)) --
				(Just (IR0 (InitDeclarator (Declarator (Nothing) (IdentifierDeclarator "t")) (ExpressionInitialiser example_swap_e1)))))
example_swap_sl		= Sn (S0 (S3 (ExpressionStatement (Just example_swap_e2)))) (S3 (ExpressionStatement (Just example_swap_e3)))
example_swap_e1		= E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Unary (Indirection) (E14 (E15 (E16 (Variable "a")))))))))))))))))
example_swap_e2		= E1 (Assignment (Unary (Indirection) (E14 (E15 (E16 (Variable "a"))))) (SimpleAssignment) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Unary (Indirection) (E14 (E15 (E16 (Variable "b")))))))))))))))))))
example_swap_e3		= E1 (Assignment (Unary (Indirection) (E14 (E15 (E16 (Variable "b"))))) (SimpleAssignment) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "t")))))))))))))))))

example_sort 		= Function (Just (DeclarationSpecifier (VoidSpecifier) (Nothing))) (example_sort_r) (Nothing) (example_sort_s)
example_sort_r		= Declarator (Nothing) (PrototypeDeclarator (IdentifierDeclarator "sort") (FixedParameters (Pn (Pn (P0 example_sort_a) (example_sort_i)) (example_sort_j))))
example_sort_a		= NamedParameter (DeclarationSpecifier (IntSpecifier) (Nothing)) (Declarator (Nothing) (ArrayDeclarator (IdentifierDeclarator "a") (Nothing)))
example_sort_i		= NamedParameter (DeclarationSpecifier (IntSpecifier) (Nothing)) (Declarator (Nothing) (IdentifierDeclarator "i"))
example_sort_j		= NamedParameter (DeclarationSpecifier (IntSpecifier) (Nothing)) (Declarator (Nothing) (IdentifierDeclarator "j"))
example_sort_s		= CompoundStatement (Nothing) (Just (S0 (S4 (IfStatement (example_sort_e1) (S2 (CompoundStatement (Just example_sort_dl) (Just example_sort_sl)))))))
example_sort_e1		= E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (GreaterThan --
				(E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "j")))))))) --
				(E11 (Sum --
					(E12 (E13 (E14 (E15 (E16 (Variable "i")))))) --
					(E13 (E14 (E15 (E16 integerConstantOne)))))))))))))))
example_sort_dl		= D0 (Declaration (DeclarationSpecifier (IntSpecifier) (Nothing)) (Just (IRn (IRn (IR0 example_sort_ir1) (example_sort_ir2)) (example_sort_ir3))))
example_sort_ir1	= InitDeclarator (Declarator (Nothing) (IdentifierDeclarator "p")) --
				(ExpressionInitialiser (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (ArraySubscript --
					(E16 (Variable "a")) --
					(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "i")))))))))))))))))))))))))))))))))
example_sort_ir2	= InitDeclarator (Declarator (Nothing) (IdentifierDeclarator "l")) --
				(ExpressionInitialiser (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (Sum --
					(E12 (E13 (E14 (E15 (E16 (Variable "i")))))) --
					(E13 (E14 (E15 (E16 integerConstantOne))))))))))))))))
example_sort_ir3	= InitDeclarator (Declarator (Nothing) (IdentifierDeclarator "r")) --
				(ExpressionInitialiser (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "j")))))))))))))))))
example_sort_sl		= Sn (Sn (Sn (S0 example_sort_s1) (example_sort_s2)) (example_sort_s3)) (example_sort_s4)
example_sort_s1		= S5 (WhileStatement (E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (LessThan --
							(E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "l")))))))) --
							(E11 (E12 (E13 (E14 (E15 (E16 (Variable "r"))))))))))))))))) --
				(S2 (CompoundStatement (Nothing) --
					(Just (S0 (S4 (IfElseStatement --
						(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (LessOrEqualTo --
							(E10 (E11 (E12 (E13 (E14 (E15 (ArraySubscript --
								(E16 (Variable "a")) --
								(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "l")))))))))))))))))))))))) --
							(E11 (E12 (E13 (E14 (E15 (E16 (Variable "p"))))))))))))))))) --
						(S3 (ExpressionStatement (Just (E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Increment --
							(E15 (E16 (Variable "l"))))))))))))))))))))) --
						(S3 (ExpressionStatement (Just (E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (FunctionCall --
							(E16 (Variable "iswap")) --
							(Just (En (E0 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Unary (Address) --
									(E14 (E15 (ArraySubscript --
										(E16 (Variable "a")) --
										(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 --
											(E12 (E13 (E14 (E15 (E16 (Variable "l"))))))))))))))))))))))))))))))))))) --
								(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Unary (Address) --
									(E14 (E15 (ArraySubscript --
										(E16 (Variable "a")) --
										(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Decrement --
											(E15 (E16 (Variable "r")))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
example_sort_s2		= S3 (ExpressionStatement (Just (E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (FunctionCall --
				(E16 (Variable "iswap")) --
				(Just (En (E0 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Unary (Address) --
						(E14 (E15 (ArraySubscript --
							(E16 (Variable "a")) --
							(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Decrement --
								(E15 (E16 (Variable "l")))))))))))))))))))))))))))))))))))) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (Unary (Address) --
						(E14 (E15 (ArraySubscript --
							(E16 (Variable "a")) --
							(E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 --
								(E11 (E12 (E13 (E14 (E15 (E16 (Variable "i"))))))))))))))))))))))))))))))))))))))))))))))))))))))
example_sort_s3		= S3 (ExpressionStatement (Just (E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (FunctionCall --
				(E16 (Variable "sort")) --
				(Just (En (En (E0 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "a"))))))))))))))))) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "i"))))))))))))))))) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "l"))))))))))))))))))))))))))))))))))))
example_sort_s4		= S3 (ExpressionStatement (Just (E1 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (FunctionCall --
				(E16 (Variable "sort")) --
				(Just (En (En (E0 (E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "a"))))))))))))))))) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "r"))))))))))))))))) --
					(E2 (E3 (E4 (E5 (E6 (E7 (E8 (E9 (E10 (E11 (E12 (E13 (E14 (E15 (E16 (Variable "i"))))))))))))))))))))))))))))))))))))

translated_example = unJust (meaningOfTranslationUnit example)

swap 	= "iswap"
sort 	= "sort"
a	= "a"
b	= "b"
t	= "t"
i	= "i"
j	= "j"
p	= "p"
l	= "l"
r	= "r"

\end{code}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	%%%%%%%	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\LocalHaskellToken	{swap}					{Ord}	{{\SetFont{Courier}{medium}{italic}swap}}
\LocalHaskellToken	{sort}					{Ord}	{{\SetFont{Courier}{medium}{italic}sort}}
\LocalHaskellToken	{a}					{Ord}	{{\SetFont{Courier}{medium}{italic}a}}
\LocalHaskellToken	{b}					{Ord}	{{\SetFont{Courier}{medium}{italic}b}}
\LocalHaskellToken	{t}					{Ord}	{{\SetFont{Courier}{medium}{italic}t}}
\LocalHaskellToken	{i}					{Ord}	{{\SetFont{Courier}{medium}{italic}i}}
\LocalHaskellToken	{j}					{Ord}	{{\SetFont{Courier}{medium}{italic}j}}
\LocalHaskellToken	{p}					{Ord}	{{\SetFont{Courier}{medium}{italic}p}}
\LocalHaskellToken	{l}					{Ord}	{{\SetFont{Courier}{medium}{italic}l}}
\LocalHaskellToken	{r}					{Ord}	{{\SetFont{Courier}{medium}{italic}r}}

\FormatLocalCSymbol	{swap}						{{\SetFont{Courier}{medium}{italic}swap}}
\FormatLocalCSymbol	{sort}						{{\SetFont{Courier}{medium}{italic}sort}}
\FormatLocalCSymbol	{a}						{{\SetFont{Courier}{medium}{italic}a}}
\FormatLocalCSymbol	{b}						{{\SetFont{Courier}{medium}{italic}b}}
\FormatLocalCSymbol	{t}						{{\SetFont{Courier}{medium}{italic}t}}
\FormatLocalCSymbol	{i}						{{\SetFont{Courier}{medium}{italic}i}}
\FormatLocalCSymbol	{j}						{{\SetFont{Courier}{medium}{italic}j}}
\FormatLocalCSymbol	{p}						{{\SetFont{Courier}{medium}{italic}p}}
\FormatLocalCSymbol	{l}						{{\SetFont{Courier}{medium}{italic}l}}
\FormatLocalCSymbol	{r}						{{\SetFont{Courier}{medium}{italic}r}}

\set{label}{C/Example}
\set{title}{Extended Example}
\begin{section}

Much can be said about the translation of C programs described on the previous 124 pages. The reader should, by now, be aware that the "meaningOfTranslationUnit" algorithm defined in Section \ref{C/Definitions} specifies both the semantic meaning of an entire translation unit in a C program and a compiler for that unit that targets some unspecified Etude implementation, such as the one described later in Chapter \ref{MMIX} and Appendix \ref{C/Implementation}. When applied to some translation unit "tu" in the context of an exception monad akin to the one represented by the standard Haskell type “Maybe”, "meaningOfTranslationUnit{--}(tu)" always derives an Etude module "m" that captures the unit's precise meaning, or else returns the monad's exceptional value “fail” if "tu" fails to satisfy some of the constraints imposed on its syntax by the C Standard. If desired, the precise reason for rejection of "tu" could be easily incorporated into that “fail” value. In fact, such diagnostic messages are already present in the actual Haskell source code from which this presentation has been prepared and they are only hidden in its typesetting for the sake of conciseness.

By its very nature, the semantic translation captured in Section \ref{C/Definitions} by the function "meaningOfTranslationUnit" can only handle translation units that, in Haskell, are represented as well-defined finite data structures. For example, the translation process would always diverge if the undefined Haskell value “\!"undefined"\!” or some infinitely-recursive list of syntactic entities was to be embedded somewhere within "tu". Due to the inherent unsolvability of the halting problem, there is very little that can be done to alleviate this limitation of the intentional compiler design technique pursued in this work. Fortunately, in real life, all translation units are produced by a parser from their finite textual representations and, accordingly, in practice, they will never contain such rogue entities.

Nevertheless, it seems advisable to formalise the precise termination guarantees for our compiler. Under the extended Haskell type system from Chapter \ref{Haskell}, this criteria can be can described concisely by the following trivial theorem, which, intuitively, states that, for every well-defined C translation unit "tu", the Etude module produced by its translation "meaningOfTranslationUnit{--}(tu)" is likewise guaranteed to be well-formed:

\NewHaskellToken	{meaningOfTranslationUnitJ}		{Ord}	{\TKeyword{tu}}
\NewHaskellDescription	{meaningOfTranslationUnitJ}			{Termination properties of the translation system}
\IndexTheorem		{meaningOfTranslationUnitJ}			{TU Termination of the translation system}

\begin{haskell}
meaningOfTranslationUnitJ :: forall tu => WfJ{--}(tu) -> WfJ{--}(meaningOfTranslationUnit{--}(tu) :: Maybe (ModuleT))
\end{haskell}

assuming that the default definition of the property “"WfJ :: Maybe TranslationUnitT -> Prop"” has been derived implicitly from the structure of the Haskell type “"Maybe TranslationUnitT"\!”, in accordance with the algorithm described in Section \ref{Haskell/Proofs}, which ensures that the value of "tu" does not contain any infinite or otherwise undefined components embedded within its syntax and, further, observing that the exceptional value “Nothing” of the Haskell monad “Maybe” is always well-formed under every such implicitly-derived definition of that property.

A detailed proof of this theorem is left as an exercise for the reader. Strictly speaking, it is not required for a simple establishment of the linear correctness property for our compiler, since, under its definition in Chapter \ref{Design}, that property is only concerned with those compiler inputs that result in a meaningful Etude program after translation. A detailed formulation of this proof is complicated by the translation's reliance on partial Haskell functions, circular definitions and outright-infinite data structures. Nevertheless, it is my belief that a substantial progress in the area could be made with the aid of capable termination checkers such as AProVE [Giesl04], which is already geared towards analysis of Haskell programs.

In the meantime, let us conclude our treatment of C with a detailed translation of a realistic C program into its Etude representation. In particular, let us consider the following textbook implementation of the quick sort algorithm in C:

\begin{C}
void swap(int *a, int *b) {
	int t = *a;
	*a = *b;
	*b = t;
}

void sort(int a[], int i, int j) {
	if (j > i + 1) {
		int p = a[i], l = i + 1, r = j;
		while (l < r) {
			if (a[l] <= p) {
				++l;
			}
			else {
				swap(&a[l], &a[--r]);
			}
		}
		swap(&a[--l], &a[i]);
		sort(a, i, l);
		sort(a, r, i);
	}
}
\end{C}

From this input, the algorithm "meaningOfTranslationUnit" derives the following Etude module:

\begin{haskell}
MODULE (
{-quad-}LET  [{-hv-}[] =: {-hide-}RET {-hv-}[]] $
{-quad-}RET  [])
{-EXPORT-} (
{-quad-}"iswap"		=: EVar swap
{-quad-}"sort"		=: EVar sort)
{-WHERE-} (
{-quad-}EVar swap 	=: FUNI $ FUN [IVar 2 {-hv-}, IVar 3] {-DOT-} $ {-~-} ..
{-quad-}IVar 5 		=: FUNI $ FUN [IVar 2 {-hv-}, IVar 3] {-DOT-} $ {-~-} ..
{-quad-}EVar sort 	=: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9] {-DOT-} $ {-~-} ..
{-quad-}IVar 13 	=: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9 {-hv-}, IVar 10 {-hv-}, IVar 11 {-hv-}, IVar 12] {-DOT-} $ {-~-} ..
{-quad-}IVar 16 	=: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9 {-hv-}, IVar 10 {-hv-}, IVar 11 {-hv-}, IVar 12] {-DOT-} $ {-~-} ..
{-quad-}IVar 17		=: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9 {-hv-}, IVar 10 {-hv-}, IVar 11 {-hv-}, IVar 12] {-DOT-} $ {-~-} ..
{-quad-}IVar 26 	=: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9] {-DOT-} $ {-~-} ..
{-quad-}IVar 27 	=: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9] {-DOT-} $ {-~-} ..)
\end{haskell}

which exports precisely the two externally-linked C functions \C{swap} and \C{sort}, bound internally to Etude variables of the same names. The constructed module initialiser represents a sequence of two trivial Etude terms “"RET []"” contributed to the program by the pair of external declarations in the above translation unit. Given a simple transformation of the program derived from the algebraic semantics of Etude terms described in Section \ref{Lambda/Terms}, this initialiser could be easily reduced into a single “"RET []"” construct, but, for the sake of conciseness, all such optimisations are avoided by our compiler at the present time.

The set of item definitions in the constructed module contains the bindings of \C{swap} and \C{sort} to their corresponding Etude functions, together with a specification of six additional functions "IVar 5", "IVar 13", "IVar 16", "IVar 17", "IVar 26" and "IVar 27" that serve as denotations of the individual basic blocks in the program. Their parameter lists reflect the variable scopes current at the beginning of the corresponding labelled statements and their actual bodies are discussed systematically throughout the remainder of this section.

In particular, the definition of \C{swap} introduces two basic blocks "EVar swap" and "IVar 5" into the module, corresponding to the function's entry and exit points, respectively. The actual Etude functions used to represent these basic blocks accept two parameter variables "IVar 2" and "IVar 3", which correspond to the respective parameter declarations \hbox{“\C{int *a}”} and \hbox{“\C{int *b}”.} Observe that, since the C function \C{swap} has the return type of “"VoidType"\,”, the parameter list of its Etude translation does not include a result object, so that the variable "IVar 1" reserved for that purpose by "meaningOfTranslationUnit" does not appear in the following \hbox{Etude code:}

\begin{haskell}
EVar swap =: FUNI $ FUN [IVar 2 {-hv-}, IVar 3] {-DOT-} $

{-{ 

First of all, "EVar swap" begins with a translation of the C declaration “\C{int t}”. Under the MMIX architecture defined in Chapter \ref{MMIX} and the corresponding C implementation from Appendix \ref{C/Implementation}, all objects of this C type are associated with the Etude format “"ZG`FMT`32"”, so that this declaration is translated into the term “"NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])"” and bound to a new Etude variable "IVar 4", which will henceforth represent its C counterpart \C{t} within the program, observing that the object's envelope does not include any access attributes, since \C{t} has an unqualified type:

}-}

	LET[	{-raw-}[IVar 4] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $

{-{

In the resulting monadic sequence, this declaration is followed immediately by an Etude depiction of its initialiser “\C{t = *a}”:
	
}-}

	LET[	{-hv-}[] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 2)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (OG`FMT`62)] $
					GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
			LET[	{-hv-}[] ---
				  =:	INI   (VAR (IVar 4) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1))))] $
			RET	[]] $

{-{

The innermost “"LET..GET"” term form of this construct obtains the value of the argument \C{a}, as depicted by the Etude variable "IVar 2", which, under the MMIX architecture, is assigned the standard object format “"OG`FMT`62"” common to all integer pointers. Next, the surrounding “"LET..GET"” implements the indirection operation “\C{*a}” and, finally, the following “"LET..INI"” populates the memory-resident object \C{t} with an actual result of that operation. Throughout the entire construction, every intermediate result is stored in the same temporary Etude variable "TVar 1". 
	
Next comes the Etude rendition of the assignment operation “\C{*a = *b}”, whose translation follows a similar structure to that of the initialiser described above, observing, however, that, in the present construct, the two operands of “\C{=}” are placed in the same Etude “"LET"” group, in order to capture the unspecified aspect of their evaluation order. Specifically, the following term binds the l-value “\C{*a}” to its Etude counterpart "TVar 1", the value of “\C{*b}” to "TVar 2" and, finally, saves the result of converting “\C{*a}” into the type of the targeted object as the temporary Etude variable "TVar 3":

}-}

	LET[	{-hv-}[] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 2)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (OG`FMT`62) {-hv-},
						{-raw-}[TVar 2] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	LET[	{-raw-}[TVar 1] ---
										  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 3)]] $
									GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (OG`FMT`62)] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					LET[	{-raw-}[TVar 3] ---
						  =:	{--}{-hide-}RET {-raw-}[OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))]] $
					LET[	{-hv-}[] ---
						  =:	SET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} (VAR (TVar 3))] $
					RET	[VAR (TVar 3)]] $
			RET	[]] $

{-{

In the same manner, the next expression statement “\C{*b = t}” is depicted by a “"LET"” structure of the following form:

}-}

	LET[	{-hv-}[] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 3)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (OG`FMT`62) {-hv-},
						{-raw-}[TVar 2] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 4)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					LET[	{-raw-}[TVar 3] ---
						  =:	{--}{-hide-}RET {-raw-}[OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))]] $
					LET[	{-hv-}[] ---
						  =:	SET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} (VAR (TVar 3))] $
					RET	[VAR (TVar 3)]] $
			RET	[]] $
					
{-{
	
Before returning to the caller, the function purges its local variable \C{t} from the program's address space using a term of the form “"DEL (xi_set)"”, in which "xi_set" is the same envelope as that applied by the corresponding “"NEW (xi_set)"” term earlier within the function. Observe that Etude is perfectly capable of figuring out that the operation pertains to the most-recently introduced object, which, in this case, represents the function's sole contribution to its address space, i.e., the required variable \C{t}:

}-}

	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $
		  
{-{

Once the original address space current upon the original entry into \C{swap} has been restored, we can proceed with a jump to the function's exit block "IVar 5", as depicted by the following tail call, whose argument list is constructed from all of the remaining variables in the current scope, i.e, the two function arguments \C{a} and \C{b}:

}-}
	APP (VAR (IVar 5)) [VAR (IVar 2) {-hv-}, VAR (IVar 3)]
\end{haskell}

Like every such exit block in the program, an actual body of the Etude function "IVar 5" consists entirely of the trivial Etude term “"RET []"”, that, in effect, leaves the continuation passing structure of the function's control-flow graph and returns immediately to its original caller:

\begin{haskell}
IVar 5 =: FUNI $ FUN [IVar 2 {-hv-}, IVar 3] {-DOT-} $
	RET	[]
\end{haskell}

A translation of the \C{sort} function is rather more complicated. In its Etude representation, the three parameter variables \C{a}, \C{i} and \C{j} are depicted by "IVar 7", "IVar 8" and "IVar 9". Once again, since this C function has a “"VoidType"\,” type, the variable "IVar 6" reserved for its returned object is left unused in the program:

\begin{haskell}
EVar sort =: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9] {-DOT-} $

{-{
	
First of all, \C{sort} begins with a trivial Etude term “"RET []"” derived from the empty list of declarations hidden at the beginning of its body statement:
 
}-}

	LET[	{-hv-}[] ---
		  =:	{--}{-hide-}RET {-hv-}[]] $
				    
{-{
	
It then proceeds with an evaluation of the controlling expression “\!\C{j > i + 1}” found in its outermost “\C{if}” statement, using a nested “"LET"” structure akin to the earlier depiction of the assignment operations in \C{swap}:
	
}-}
				    
	LET[	{-raw-}[TVar 1] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 9)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-hv-},
						{-raw-}[TVar 2] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	LET[	{-raw-}[TVar 1] ---
										  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 8)]] $
									GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-hv-},
								{-raw-}[TVar 2] ---
								  =:	{--}{-hide-}RET {-raw-}[IMM (1) (ZG`FMT`32)]] $
							RET	[OP2 ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) --
									(ADD) (ZG`FMT`32) ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
					RET	[OP2 ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) --
							(CGT) (ZG`FMT`32) ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
			RET	[OP2 (VAR (TVar 1)) (CNE) (ZG`FMT`32) (IMM (0) (ZG`FMT`32))]] $

{-{
	
Once "TVar 1" has been set to the desired condition, its value is applied in the actual “\C{if}” statement as follows. In the “"True"” branch, we begin with a declaration of the three integer variables \C{p}, \C{l} and \C{r} found at the top of the corresponding compound statement, which will henceforth be represented by "IVar 10", "IVar 11" and "IVar 12", respectively:

}-}

	IFF (VAR (TVar 1)) {-THEN-} (
	{-Q-}	 LET[	 {-raw-}[IVar 10] ---
			   =:	 NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $
		 LET[	 {-raw-}[IVar 11] ---
			   =:	 NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $
		 LET[	 {-raw-}[IVar 12] ---
			   =:	 NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $

{-{

Next, the new memory-resident object \C{p} that is specified by the first of these variables "IVar 10" must be populated with its initialiser expression “\C{a[i]}\!”:

}-}

		 LET[	 {-hv-}[] ---
			   =:	 LET[	 {-hv-}[] ---
					   =:	 LET[	 {-hv-}[] ---
							   =:	 LET[	 {-raw-}[TVar 1] ---
									   =:	 LET[	 {-raw-}[TVar 1] ---
											   =:	 LET[	 {-raw-}[TVar 1] ---
													   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 7)] {-hv-},
													 {-raw-}[TVar 2] ---
													   =:	 LET[	 {-raw-}[TVar 1] ---
															   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 8)]] $
														 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
												 RET	 [OP2 (VAR (TVar 1)) (ADD) (OG`FMT`62)
												 {-~-}{-~-}{-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) --
												 					{--} {-hv-}(VAR (TVar 2)))) --
												 		  		(MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64)))]] $
										 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
								 LET[	 {-hv-}[] ---
									   =:	 INI   (VAR (IVar 10) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) --
									   		{-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1))))] $
								 RET	 []] $

{-{

In the above term, the reader will doubtless notice the meticulous depiction of the pointer arithmetic performed by the initialiser, recalling that all array subscript operations such as  “\C{a[i]}\!” are essentially rendered equivalent to “\C{*((a)+i)}\!” by their translation in Section \ref{C/Expressions}. Under that interpretation, the l-value examined by the above initialiser is depicted by the Etude expression “"OP2 (VAR (TVar 1)) (ADD) (OG`FMT`62) ({-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2)))) (MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64))))"” which, intuitively, increments the value of the pointer \C{a} that is stored in "TVar 1" by the product of the integer \C{i} (or "TVar 2"), converted into the standard integer format “"ZG`FMT`64"” and multiplied by the size of the pointer's referenced type, equal to 4 bytes on the MMIX architecture.

Similarly, the C variable \C{l}, which masquerades as "IVar 11" in the constructed Etude module, is initialised to “\C{i + 1}”:

\vskip-6pt

}-}

						 LET[	 {-raw-}[TVar 1] ---
							   =:	 LET[	 {-raw-}[TVar 1] ---
									   =:	 LET[	 {-raw-}[TVar 1] ---
											   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 8)]] $
										 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-hv-},
									 {-raw-}[TVar 2] ---
									   =:	 {--}{-hide-}RET {-raw-}[IMM (1) (ZG`FMT`32)]] $
								 RET	 [OP2 ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) --
								 		(ADD) (ZG`FMT`32) ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
						 LET[	 {-hv-}[] ---
							   =:	 INI   (VAR (IVar 11) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) --
							   		{-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1))))] $
						 RET	 []] $

{-{

Finally, the variable \C{r} (or "IVar 12") is assigned the value of \C{j} as requested by the source program:

\vskip-6pt

}-}
				 
				 LET[	 {-raw-}[TVar 1] ---
					   =:	 LET[	 {-raw-}[TVar 1] ---
							   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 9)]] $
						 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
				 LET[	 {-hv-}[] ---
					   =:	 INI   (VAR (IVar 12) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) --
					   		{-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1))))] $
				 RET	 []] $

{-{ 

The unusually-deep nesting structure of these initialisers is a direct result of the means by which the denotations of individual initialiser expressions are composed into a single Etude term during their translation in Section \ref{C/Declarations/InitDeclarators}. In particular, given two initialisers with the meaning of "tau1" and "tau2", the collective denotation of the surrounding declarator list would have the form of “"LET [{-hv-}[] =: tau1] (tau2)"\!”, although the reader should not be overly alarmed by this complexity, given that even the simplest of all optimising compilers would break no sweat when asked to reduce the resulting structure back into its pleasantly-flat representation.

Once all three of our local variables have been assigned their correct initial values, we are ready to proceed with a call to the body of the translated “\C{while}” loop, whose basic block is bound below to the Etude variable "IVar 13", supplying it with all six local variables visible in the current scope, i.e., \C{a}, \C{i}, \C{j}, \C{p}, \C{l} and \C{r}:

}-}

		 APP (VAR (IVar 13)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9) {-hv-}, VAR (IVar 10) {-hv-}, VAR (IVar 11) {-hv-}, VAR (IVar 12)])

{-{

Otherwise, in the implied “\C{else}” branch of the above “\C{if}” statement, control is simply transferred to the conditional's exit block "IVar 26", whose local scope consists entirely of the three function arguments \C{a}, \C{i} and \C{j}:

}-}

	{-ELSE-} (
	{-Q-}	 APP (VAR (IVar 26)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9)])
\end{haskell}

The actual body of the loop found at the heart of \C{swap} is represented in Etude by the following function:

\begin{haskell}
IVar 13 =: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9 {-hv-}, IVar 10 {-hv-}, IVar 11 {-hv-}, IVar 12] {-DOT-} $

{-{

which, predictably, begins with an evaluation of the controlling expression “\C{l < r}\,” from the corresponding “\C{while}” statement:

}-}

	LET[	{-raw-}[TVar 1] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 11)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-hv-},
						{-raw-}[TVar 2] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 12)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					RET	[OP2 ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) --
							(CLT) (ZG`FMT`32) ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
			RET	[OP2 (VAR (TVar 1)) (CNE) (ZG`FMT`32) (IMM (0) (ZG`FMT`32))]] $

{-{

If that expression has a true value, we can proceed with an evaluation of the loop's nested statement. Once again, that statement begins with an empty set of declaration initialisers that are translated into the trivial Etude term “"RET []"”:

}-}

	IFF (VAR (TVar 1)) {-THEN-} (
	{-Q-}	 LET[	 {-hv-}[] ---
			   =:	 {--}{-hide-}RET {-hv-}[]] $
			   
{-{

Here, the first task on the program's agenda is an evaluation of the controlling expression “\C{a[l] <= p}” from the “\C{if}\,” statement embedded within the loop's body:

}-}

		 LET[	 {-raw-}[TVar 1] ---
			   =:	 LET[	 {-raw-}[TVar 1] ---
					   =:	 LET[	 {-raw-}[TVar 1] ---
							   =:	 LET[	 {-raw-}[TVar 1] ---
									   =:	 LET[	 {-raw-}[TVar 1] ---
											   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 7)] {-hv-},
											 {-raw-}[TVar 2] ---
											   =:	 LET[	 {-raw-}[TVar 1] ---
													   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 11)]] $
												 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
										 RET	 [OP2 (VAR (TVar 1)) (ADD) (OG`FMT`62)
										 {-~-}{-~-}{-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2)))) --
										 				(MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64)))]] $
								 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-hv-},
							 {-raw-}[TVar 2] ---
							   =:	 LET[	 {-raw-}[TVar 1] ---
									   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 10)]] $
								 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
						 RET	 [OP2 ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) --
						 		(CLE) (ZG`FMT`32) ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
				 RET	 [OP2 (VAR (TVar 1)) (CNE) (ZG`FMT`32) (IMM (0) (ZG`FMT`32))]] $

{-{
		 
If true, this expression prompts a reduction of the unary increment operation “\C{++l}\,”, as represented by the following predictable “"LET"” structure:

}-}
				 
		 IFF (VAR (TVar 1)) {-THEN-} (
		 {-Q-}	 LET[	 {-hv-}[] ---
				   =:	 LET[	 {-raw-}[TVar 1] ---
						   =:	 LET[	 {-raw-}[TVar 1] ---
								   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 11)] {-hv-},
								 {-raw-}[TVar 2] ---
								   =:	 {--}{-hide-}RET {-raw-}[IMM (1) (ZG`FMT`32)]] $
							 LET[	 {-raw-}[TVar 3] ---
								   =:	 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
							 LET[	 {-raw-}[TVar 4] ---
								   =:	 {--}{-hide-}RET {-raw-}[OP2 (VAR (TVar 3)) --
								   					(ADD) (ZG`FMT`32) --
								   					({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
							 LET[	 {-hv-}[] ---
								   =:	 SET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} (VAR (TVar 4))] $
							 RET	 [VAR (TVar 4)]] $
					 RET	 []] $

{-{

Once the value of \C{l} has been updated, we simply proceed with a jump to the exit block "IVar 16" of the current selection statement, retaining all six of the C variables \C{a}, \C{i}, \C{j}, \C{p}, \C{l} and \C{r} from its surrounding scope:

}-}
					 
			 APP (VAR (IVar 16)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9) {-hv-}, VAR (IVar 10) {-hv-}, VAR (IVar 11) {-hv-}, VAR (IVar 12)])

{-{
		 
Otherwise, the program allocates a pair of internal pointer variables "IVar 14" and "IVar 15", whose Etude format “"OG`FMT`64"” corresponds directly to the C type “\C{int *}\!”, as required for storage of the argument values during the upcoming call to the \C{swap} function:

}-}
				 
		 {-ELSE-} (
		 {-Q-}	 LET[	 {-raw-}[IVar 14] ---
				   =:	 NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $
			 LET[	 {-raw-}[IVar 15] ---
				   =:	 NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $

{-{

The actual address of that function is then placed into the temporary variable "TVar 1":

}-}

			 LET[	 {-hv-}[] ---
				   =:	 LET[	 {-raw-}[TVar 1] ---
						   =:	 {--}{-hide-}RET {-raw-}[VAR (EVar swap)] {-hv-},

{-{

and the temporary argument object "IVar 14", which corresponds to the function's initial operand \C{a}, is populated with its required value of “\C{&a[l]}\!”:

}-}

						 {-hv-}[] ---
						   =:	 LET[	 {-raw-}[TVar 1] ---
								   =:	 LET[	 {-raw-}[TVar 1] ---
										   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 7)] {-hv-},
										 {-raw-}[TVar 2] ---
										   =:	 LET[	 {-raw-}[TVar 1] ---
												   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 11)]] $
											 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
									 RET	 [OP2 (VAR (TVar 1)) --
									 		(ADD) (OG`FMT`62) --
									 		({-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2)))) --
									 			(MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64))))]] $
							 INI   (VAR (IVar 14) {-hide-}, {-hide-}emptySet) (OG`FMT`62) --
							 	{-TO-} ({-hv-}(OP1 (CNV (OG`FMT`62)) (OG`FMT`62) {--} {-hv-}(VAR (TVar 1)))) {-hv-},

{-{

Similarly, the second argument "IVar 15" is set to “\C{&a[--r]}\!”:

}-}

						 {-hv-}[] ---
						   =:	 LET[	 {-raw-}[TVar 1] ---
								   =:	 LET[	 {-raw-}[TVar 1] ---
										   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 7)] {-hv-},
										 {-raw-}[TVar 2] ---
										   =:	 LET[	 {-raw-}[TVar 1] ---
												   =:	 {--}{-hide-}RET {-raw-}[VAR (IVar 12)] {-hv-},
												 {-raw-}[TVar 2] ---
												   =:	 {--}{-hide-}RET {-raw-}[IMM (1) (ZG`FMT`32)]] $
											 LET[	 {-raw-}[TVar 3] ---
												   =:	 GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
											 LET[	 {-raw-}[TVar 4] ---
												   =:	 {--}{-hide-}RET {-raw-}[OP2 (VAR (TVar 3)) --
												   				 (SUB) (ZG`FMT`32) --
												   				 ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) --
												   				 		{--} {-hv-}(VAR (TVar 2))))]] $
											 LET[	 {-hv-}[] ---
												   =:	 SET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) --
												   		{-TO-} (VAR (TVar 4))] $
											 RET	 [VAR (TVar 4)]] $
									 RET	 [OP2 (VAR (TVar 1)) --
									 		(ADD) (OG`FMT`62) --
									 		({-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2)))) --
									 				(MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64))))]] $
							 INI   (VAR (IVar 15) {-hide-}, {-hide-}emptySet) (OG`FMT`62) --
							 	{-TO-} ({-hv-}(OP1 (CNV (OG`FMT`62)) (OG`FMT`62) {--} {-hv-}(VAR (TVar 1))))] $

{-{ 

at which point we are ready to perform the actual function application:

}-}

					 APP (VAR (TVar 1)) [VAR (IVar 14) {-hv-}, VAR (IVar 15)]] $

{-{ 

Next, we wrap up the representation of the current expression statement by purging the temporary variables "IVar 15" and "IVar 14" from the program's address space, in the reverse order of their earlier introduction by the corresponding “"NEW"” terms:

}-}

			 LET[	 {-hv-}[] ---
				   =:	 DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $
			 LET[	 {-hv-}[] ---
				   =:	 DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $

{-{

Finally, we can conclude the entire “\C{if}\,” statement with a jump to its exit block "IVar 16", once again retaining the entire scope of the surrounding statement:

}-}

			 APP (VAR (IVar 16)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9) {-hv-}, VAR (IVar 10) {-hv-}, VAR (IVar 11) {-hv-}, VAR (IVar 12)]))

{-{

Otherwise, the loop's controlling expression “\!\C{l < r}\,” must have a false value and, accordingly, we can leave the “\C{while}” statement immediately with a jump to its exit block "IVar 17" that is rendered in Etude as follows:

}-}

	{-ELSE-} (
	{-Q-}	 APP (VAR (IVar 17)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9) {-hv-}, VAR (IVar 10) {-hv-}, VAR (IVar 11) {-hv-}, VAR (IVar 12)])
\end{haskell}

As already mentioned, the Etude variable "IVar 16" is bound to the exit block of the inner “\C{if}\,” statement in the body of \C{swap}, which simply transfers control back to the beginning of the loop, as represented by the following tail call to the corresponding Etude function "IVar 13":

\begin{haskell}
IVar 16 =: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9 {-hv-}, IVar 10 {-hv-}, IVar 11 {-hv-}, IVar 12] {-DOT-} $
	APP (VAR (IVar 13)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9) {-hv-}, VAR (IVar 10) {-hv-}, VAR (IVar 11) {-hv-}, VAR (IVar 12)]
\end{haskell}

On the other hand, the loop's own exit block "IVar 17" continues as follows:

\begin{haskell}
IVar 17 =: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9 {-hv-}, IVar 10 {-hv-}, IVar 11 {-hv-}, IVar 12] {-DOT-} $

{-{

First, we need to allocate a pair of new Etude variables "IVar 18" and "IVar 19" for the impending call to the C function \C{swap}:

}-}

	LET[	{-raw-}[IVar 18] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-raw-}[IVar 19] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $

{-{

As per the original C program, their values are initialised to “\C{&a[--l]}\!” and “\C{&a[i]}\!”. The actual call is then performed by the application term “"APP (VAR (TVar 1)) [VAR (IVar 18) {-hv-}, VAR (IVar 19)]"”:

}-}

	LET[	{-hv-}[] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	{--}{-hide-}RET {-raw-}[VAR (EVar swap)] {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 7)] {-hv-},
								{-raw-}[TVar 2] ---
								  =:	LET[	{-raw-}[TVar 1] ---
										  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 11)] {-hv-},
										{-raw-}[TVar 2] ---
										  =:	{--}{-hide-}RET {-raw-}[IMM (1) (ZG`FMT`32)]] $
									LET[	{-raw-}[TVar 3] ---
										  =:	GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
									LET[	{-raw-}[TVar 4] ---
										  =:	{--}{-hide-}RET {-raw-}[OP2 (VAR (TVar 3)) --
										  				(SUB) (ZG`FMT`32) --
										  				({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2))))]] $
									LET[	{-hv-}[] ---
										  =:	SET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} (VAR (TVar 4))] $
									RET	[VAR (TVar 4)]] $
							RET	[OP2 (VAR (TVar 1)) --
									(ADD) (OG`FMT`62) --
									({-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2)))) --
											(MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64))))]] $
					INI   (VAR (IVar 18) {-hide-}, {-hide-}emptySet) (OG`FMT`62) --
						{-TO-} ({-hv-}(OP1 (CNV (OG`FMT`62)) (OG`FMT`62) {--} {-hv-}(VAR (TVar 1)))) {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 7)] {-hv-},
								{-raw-}[TVar 2] ---
								  =:	LET[	{-raw-}[TVar 1] ---
										  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 8)]] $
									GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
							RET	[OP2 (VAR (TVar 1)) --
									(ADD) (OG`FMT`62) --
									({-hv-}(OP2 ({-hv-}(OP1 (CNV (ZG`FMT`64)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 2)))) --
											(MUL) (ZG`FMT`64) (IMM (4) (ZG`FMT`64))))]] $
					INI   (VAR (IVar 19) {-hide-}, {-hide-}emptySet) (OG`FMT`62) --
						{-TO-} ({-hv-}(OP1 (CNV (OG`FMT`62)) (OG`FMT`62) {--} {-hv-}(VAR (TVar 1))))] $
			APP (VAR (TVar 1)) [VAR (IVar 18) {-hv-}, VAR (IVar 19)]] $

{-{

At the end of the entire expression statement, these temporary variables are no longer required and, accordingly, they are purged from the program's address space, ignoring the fact that they could be easily reused in a subsequent call to \C{sort}:

}-}
			
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG`FMT`62 {-hide-}, {-hide-}emptySet)])] $

{-{

Next comes a translation of the expression statement “\C{sort(a, i, l);}\!”, for which we reserve the three Etude variables "IVar 20", "IVar 21" and "IVar 22", observing that the first argument of \C{sort} represents a pointer, but the other two have the integer format “"ZG`FMT`32"”:

}-}

	LET[	{-raw-}[IVar 20] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG   `FMT`62 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-raw-}[IVar 21] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG   `FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-raw-}[IVar 22] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG   `FMT`32 {-hide-}, {-hide-}emptySet)])] $

{-{

The actual function call operation “\C{sort(a, i, l)}\!” is then performed by the following sequence of Etude assignments and application terms:

}-}

	LET[	{-hv-}[] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	{--}{-hide-}RET {-raw-}[VAR (EVar sort)] {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 7)]] $
					INI   (VAR (IVar 20) {-hide-}, {-hide-}emptySet) (OG`FMT`62) {-TO-} ({-hv-}(OP1 (CNV (OG`FMT`62)) (OG`FMT`62) {--} {-hv-}(VAR (TVar 1)))) {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 8)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					INI   (VAR (IVar 21) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 11)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					INI   (VAR (IVar 22) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1))))] $
			APP (VAR (TVar 1)) [VAR (IVar 20) {-hv-}, VAR (IVar 21) {-hv-}, VAR (IVar 22)]] $

{-{

Once again, the three argument objects "IVar 22", "IVar 21" and "IVar 20" are quietly discarded at the end of that expression statement, in the proper reverse order of their earlier allocation:

}-}

	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG	    `FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG	    `FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG	    `FMT`62 {-hide-}, {-hide-}emptySet)])] $

{-{

Similarly, the second call to \C{swap} with the argument list of “\!\C{(a, r, i)}\!” is translated into the following monadic sequence:

}-}

	LET[	{-raw-}[IVar 23] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG    `FMT`62 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-raw-}[IVar 24] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG    `FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-raw-}[IVar 25] ---
		  =:	NEW (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG    `FMT`32 {-hide-}, {-hide-}emptySet)])] $

	LET[	{-hv-}[] ---
		  =:	LET[	{-raw-}[TVar 1] ---
				  =:	{--}{-hide-}RET {-raw-}[VAR (EVar sort)] {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 7)]] $
					INI   (VAR (IVar 23) {-hide-}, {-hide-}emptySet) (OG`FMT`62) {-TO-} ({-hv-}(OP1 (CNV (OG`FMT`62)) (OG`FMT`62) {--} {-hv-}(VAR (TVar 1)))) {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 12)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					INI   (VAR (IVar 24) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1)))) {-hv-},
				{-hv-}[] ---
				  =:	LET[	{-raw-}[TVar 1] ---
						  =:	LET[	{-raw-}[TVar 1] ---
								  =:	{--}{-hide-}RET {-raw-}[VAR (IVar 8)]] $
							GET   (VAR (TVar 1) {-hide-}, {-hide-}emptySet) (ZG`FMT`32)] $
					INI   (VAR (IVar 25) {-hide-}, {-hide-}emptySet) (ZG`FMT`32) {-TO-} ({-hv-}(OP1 (CNV (ZG`FMT`32)) (ZG`FMT`32) {--} {-hv-}(VAR (TVar 1))))] $
			APP (VAR (TVar 1)) [VAR (IVar 23) {-hv-}, VAR (IVar 24) {-hv-}, VAR (IVar 25)]] $
			
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG    `FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG    `FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, OG    `FMT`62 {-hide-}, {-hide-}emptySet)])] $

{-{

At this point, all that remains in the program is the purging from its address space of the three C variables \C{p}, \C{l} and \C{r}, which are about to leave the scope of the inner compound statement in the body of \C{sort}:

}-}

	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $
	LET[	{-hv-}[] ---
		  =:	DEL (listToSet {-raw-}[{-raw-}(0 {-hv-}, ZG`FMT`32 {-hide-}, {-hide-}emptySet)])] $

{-{

Finally, we are ready to conclude the outer “\C{if}\,” statement in \C{sort} with a jump to its exit block "IVar 26":

}-}
		  
	APP (VAR (IVar 26)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9)]
\end{haskell}

where the actual implementation of that exit block is depicted in Etude by a trivial jump to the exit block "IVar 27" of the entire \C{sort} function:

\begin{haskell}
IVar 26 =: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9] {-DOT-} $
	APP (VAR (IVar 27)) [VAR (IVar 7) {-hv-}, VAR (IVar 8) {-hv-}, VAR (IVar 9)]
\end{haskell}

Last but not least, the exit block of \C{swap} itself simply returns to its ultimate caller:

\begin{haskell}
IVar 27 =: FUNI $ FUN [IVar 7 {-hv-}, IVar 8 {-hv-}, IVar 9] {-DOT-} $
	RET	[]
\end{haskell}

Perhaps the most striking feature of the above translation is its extraordinary verbosity, whereby a mere 15 lines of C has been converted into a whooping 182 lines of Etude term definitions. Unfortunately, such code explosion is all but unavoidable under translation of a high-level language akin to C into a low-level program representation such as Etude, in which all of the computational complexities imposed by the underlying instruction set architecture must be exposed with an excruciating amount of detail.

In this work, the problem of loquacity is further aggravated by our omission of even the simples optimising program transformations, which could be easily applied to the above Etude modules. For example, if we chose to propagate trivial atomic bindings such as “"LET [nu_set =: alpha_set] (tau)"” into the body term "tau", eliminate redundant operations such as automorphic conversions of the form “"OP1 (CNV phi) (phi) {--} {-hv-}(alpha)"” that specify identical source and target formats and flatten the program's deep nesting of “"LET"” statements, then the above module would be reduced to less then a half of its present length. It would also be easy to demonstrate that all such optimisations preserve the algebraic model of Etude defined earlier in Chapter \ref{Lambda} and, accordingly, to detach them from the actual translation semantics of the C programming language.

However, when it comes to a reasoning about the actual properties of individual C programs, the formal model presented in this chapter should, in principle, be able to facilitate arbitrary verification tasks for all C programs that are well-formed under the portable subset of the language. When combined with the additional information derived from its MMIX specialisation in Chapter \ref{MMIX} and Appendix \ref{C/Implementation}, even programs that rely on various implementation-defined behaviours can be analysed successfully. While it is certainly true that, due to the great amount of detail introduced by the translation, most non-trivial verification tasks would require a sensible engineering regime and, more likely than not, some degree of automation from appropriate tools, the relative directness with which the individual C constructs have been mapped onto their Etude counterparts ensures that such tools and practices can, in principle, be devised entirely within the formal framework presented in this work.

\end{section}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
